# TODO

1. How to create go objects with custom (not like player/wall/enemy has) collision boxes?
    Solutions:
    1. Multiple col boxes in component.go ? -> Multiple Handlers for different group: small, medium, large, x-large .. etc.
    2. Custom .go + custom factory + custom script ? Not so good idea.. complicates and breaks unified objects management (creation, deletion, events handling)    
2. How to render and manipulate labels near go?
    Solutions:
    1. Separate go which should "follow" primary go (position, rotation etc.)
3. Problem of big atlas?
    Solutions:
    1. Create several sprites in go and switch between them in code? + Use backgrounds for screens in separate custom code.
4. What about sounds? 
    Solutions:
    1. Create Uber-go with all sounds added to it. Send it messages to produce/stop sound from other go's
    

# Solved TODOs

1. How to create and manage collections of objects? Need when we have player holding item or items. Complex UI object (progress bar composed of several go's)
    
    **Solution:**
    
    Do not use collections at all. Use only go's and chains of go's. (May be difficult, need to manage rotations, scales of all group of go's)

2. What about non-unique objects? (tiles, projectiles, enemies?)
    
    **Solution:**
    
    Generate unique name with prefix + random uuid or increasing number (map of counters in `component_registry`)
3. Objects communication? 
    
    **Solution:**
    
    Algorithm below:
    1. Declare required component_ids in each Class (for example, self.dependencies = {...}) + Using `component_registry` 
    at `resolve_dependencies` phase (called by `game_level_objects_controller`) 
    to find required component -> store it's reference in `self.comp1`, `self.comp2` etc.
    2. Declare appropriate method in object class API in `:method(..)` format. For example: `DoorLock:open()`
    3. Find target required item in target class and call its required method. For example:
        ```
       self.door_lock:open()
        ```
4. Generating non-unique objects by some other target object?

    **Solution:**
    Any Component subclass can now create and unregister component using `component_registry` global functions (passed as lambdas in inner component's fields at creation phase)
    Example below:
    ```
    self.create_component_function(self.projectile_descriptor.type, self.projectile_descriptor.name, self.projectile_descriptor)
    ``` 