-- Put functions in this file to use them in several other scripts.
-- To get access to the functions, you need to put:
-- require "my_directory.my_file"
-- in any script using the functions.

Object = require('lib.classic.classic')

Component = Object:extend()

function Component:new(opts)
	self.transparent = vmath.vector4(0.5, 0.5, 0.5, 0.0)
	self.go_id = opts.id
	self.name = opts.name
	self.z_index = opts.z_index or 0.5
	self.original_pos = opts.pos or vmath.vector3(50, 50, self.z_index)

	if self.original_pos then 
		go.set_position(self.original_pos, self.go_id)
	end

	Component.super.new(self, opts)
end

function Component:set_unregister_component_function(unregister_component_function) 
	self.unregister_component_function = unregister_component_function
end

function Component:set_create_component_function(create_component_function) 
	self.create_component_function = create_component_function
end

function Component:init_as_game_object(opts)
	go.set("#label", "color", self.transparent)
end

function Component:set_initial_sprite(opts)
	sprite.play_flipbook("#sprite", hash("dummy_image"))
	
end

function Component:hash(opts)
	return hash("Component")
end

function Component:final(go_self)
	-- Add finalization code here
end

function Component:update(go_self, dt)
	-- Add update code here
end

function Component:resolve_dependencies() 
	-- noop here
end

function Component:on_message(go_self, message_id, message, sender)
	if message_id == hash("collision_response") then
		if message.other_group == hash("default") then 
			self:handle_collision(message.other_id)
		end
	end
end

function Component:handle_collision(other_id) 
end

function Component:on_input(go_self, action_id, action)
	-- Add input-handling code here
end

function Component:on_reload(go_self)
	-- Add reload-handling code here
end
