require 'lib.Component'

Rock = Component:extend()

local max_speed = 800

local vertical_gap = 0
local horizontal_gap = 0

local screen_height = tonumber(sys.get_config("display.height"))
local screen_width = tonumber(sys.get_config("display.width"))

local min_y = vertical_gap
local max_y = screen_height - vertical_gap

local min_x = horizontal_gap
local max_x = screen_width - horizontal_gap

function Rock:new(opts)
	self.rock_throw_speed = max_speed
	Rock.super.new(self, opts)
end

function Rock:delete_if_exited_screen(p) 
	if p.y < min_y then
		self.unregister_component_function(self.name, true)
	elseif p.y > max_y then
		self.unregister_component_function(self.name, true)
	end

	if p.x < min_x then
		self.unregister_component_function(self.name, true)
	elseif p.x > max_x then
		self.unregister_component_function(self.name, true)
	end
end

function Rock:update(go_self, dt)
	local pos = go.get_position()
	pos.x = pos.x + dt * self.rock_throw_speed
	go.set_position(pos)
end

function Rock:set_initial_sprite(opts)
	sprite.play_flipbook("#sprite", hash("item_rock"))
end

function Rock:hash(opts)
	return hash("Rock")
end

function Rock:handle_collision(other_id) 
end