-- Registry for singleton Game Objects

GO_REGISTRY = {}

-- TODO: add the functionality to the registry to delete all go.s ? 
-- TODO: what about collections ? (how to store collections, how to navigate collection's component from registry ? )
-- TODO: what about multiple objects (not singletons): projectiles, enemies, collectibles etc. ?
-- What if the object deletes itself? Solution: delete it via registry -> unregister(boolean: delete_go ?)
function reset_registry() 
	GO_REGISTRY = {}
end

function function unregister(component_name, with_go_delete) 
	local go = resolve_go(component_name)
	if true == with_go_delete then 
		go.delete()
	end
	GO_REGISTRY[component_name] = nil
end

function register(component_name, id) 
	if GO_REGISTRY[component_name] then 
		error("Component '" .. component_name .. "' already exists with the id: " .. id)
	end
	GO_REGISTRY[component_name] = id
end

function resolve_go(component_name) 
	local go = GO_REGISTRY[component_name]
	if not go then 
		error("Component '" .. component_name .. "' was not found in registry")
	end
	return go
end

register("12", 500)
print(resolve_go("12"))
print(resolve_go("132"))